package io.tswf.minecraft.blockventure.core.inventory.screenhandler

import groovy.transform.CompileStatic
import io.tswf.minecraft.blockventure.core.api.registry.GuiScreenRegistry
import net.minecraft.entity.player.PlayerEntity
import net.minecraft.item.ItemStack
import net.minecraft.screen.ScreenHandler
import net.minecraft.screen.ScreenHandlerType

@CompileStatic
abstract class BaseQuickMoveScreenHandler extends ScreenHandler {

    MultipleSlotsQuickMoveHelper quickMoving = new MultipleSlotsQuickMoveHelper(this)

    BaseQuickMoveScreenHandler(int syncId) {
        this(GuiScreenRegistry.autoSelectType, syncId)
    }

    BaseQuickMoveScreenHandler(ScreenHandlerType screenHandlerType, int syncId) {
        super(screenHandlerType, syncId)
    }

    @Override
    ItemStack quickMove(PlayerEntity player, int slot) {
        quickMoving.quickMoveStack(player, slot)
    }

    @Override
    boolean canUse(PlayerEntity player) {
        return true
    }
}
